/***********************************************************************/
/***** The Skeleton Code for the Curves Assignment for HW 2 in CS 184 **/
/***** Originally written by Aner Ben-Artzi a few years ago        *****/
/***** Modified in Dec 2009 by Ravi Ramamoorthi for more comments, *****/
/***** and consistency with modern C++ rules                         ***/

#include <stdio.h>

// To handle vectors correctly, with current namespace conventions
#include <vector>
#define vector std::vector   

#include "WorkingScene.h"

#include <GL/glut.h>

WorkingScene scene;

// Basic display and main setup routines.  
// Display just does basic OpenGL stuff to display 2D curve
// The main routine just sets up a basic display function

void display() {	
	//First, the ModelViewProjection Matrix is setup
	//this determines how the scene will be viewed
	float m[] = {	2.0, 0, 0, 0,
					0, 2.0, 0, 0,
					0, 0, 2.0, 0,
					-1.0, -1.0, 0, 1.0};
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glMultMatrixf(m);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	//Second, the framebuffer is filled with the objects in the scene
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	if (scene.theOnlyCurve) {
		scene.theOnlyCurve->draw(scene.levelOfDetail);
	}
	glutSwapBuffers();
}


//This program may have memory leaks, but we won't worry about that right now
int main(int argc, char* argv[]) {
	
	argc = 1;
	glutInit( &argc, argv );
	glutInitWindowPosition( 100, 100 );
        //	scene.width = 400;  // Should already be set by default.
	glutInitWindowSize( scene.width, scene.height );
	glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH );

	glutCreateWindow( "Drawing Curves is fun..." );
	glutDisplayFunc( display );
	glutKeyboardFunc( scene.keyboard );
	glutMouseFunc( scene.mouse );
	glutReshapeFunc( scene.reshape );
	glutPassiveMotionFunc( scene.passiveMotion );
	glutMotionFunc( scene.drag );
	
	glutMainLoop();
	return 0;
}
